unit Profil;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QButtons, QExtCtrls,IniFiles, MyHostInfo;

type
  TFProfil = class(TForm)
    Panel1: TPanel;
    BitBtn2: TBitBtn;
    TS: TTabControl;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EdDB: TEdit;
    EdUser: TEdit;
    EdPwd: TEdit;
    EdProfil: TEdit;
    EdHost: TEdit;
    HostInfo: THostInfo;
    BitBtn1: TBitBtn;
    CBHosts: TComboBox;
    Label7: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtSaveClick(Sender: TObject);
    Function LadeProfil(Nr:integer):boolean;
    Function SaveProfil(Nr:integer):boolean;
    procedure LadeAlleProfile;
    procedure CBHostsChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HostInfoActionError(Sender: TObject; PrgError: String);
  private
    { Private-Deklarationen }
    sHostProfil:string;
  public
    { Public-Deklarationen }
  end;

var
  FProfil: TFProfil;

implementation

{$R *.xfm}

uses BackDemoMain;

procedure TFProfil.FormShow(Sender: TObject);
begin
  CBHosts.Clear;
  CBHosts.Items.Assign(FMain.CBHosts.Items);
  CBHosts.ItemIndex:=FMain.CBHosts.ItemIndex;
  CBHostsChange(Self);
end;

procedure TFProfil.BtSaveClick(Sender: TObject);
var ActIndex:integer;
begin
  ActIndex:=CBHosts.ItemIndex;
  if TS.TabIndex=0 then begin
     SaveProfil(CBHosts.ItemIndex+1);
  end else begin
    if Application.MessageBox('Create new Profil?', 'Profil',
      [smbOK,smbCancel]) =  smbOK then
    begin
      SaveProfil(CBHosts.Items.count+1);
      ActIndex:=CBHosts.Items.count;
    end;
  end;
 LadeAlleProfile;
 CBHosts.ItemIndex:=ActIndex;
 CBHostsChange(Self);
 close;
end;

procedure TFProfil.CBHostsChange(Sender: TObject);
begin
  LadeProfil(CBHosts.ItemIndex+1);
  EdProfil.Text:=CBHosts.Text;
  edHost.Text:=SMyHost;
  edDb.Text:=SMyDB;
  edUser.Text:=SUser;
  edPwd.Text:=SPwd;
end;


Function TFProfil.LadeProfil(Nr:integer):boolean;
begin
  Result:=false;
  try
    HostInfo.CryptKey:=55;
    if HostInfo.LoadProfil(Nr) then begin
//        sHostProfil:=HostInfo.Profil;
        SMyHost:=HostInfo.Host;
        SMyDB:=HostInfo.Database;
        SUser:=HostInfo.User;
        SPwd:=HostInfo.Password;
        if length(SUser) > 1 then begin
         HostInfo.CryptKey:= ord(SUser[1]);
         HostInfo.LoadProfil(Nr);
         SPwd:=HostInfo.Password;
        end;
        Result:= trim(SMyHost) <> '';
    end;
  except
  end;
end;

Function TFProfil.SaveProfil(Nr:integer):boolean;
begin
  Result:=false;
  try
    with HostInfo do begin
      if length(SUser) > 1 then CryptKey:= ord(SUser[1])
      else CryptKey:=55;
      Profil:=EdProfil.Text;
      Host:=EdHost.Text;
      Database:= EdDB.Text;
      User:= EdUser.Text;
      Password:=EdPwd.Text;
    end;
    Result:=HostInfo.SaveProfil(Nr);
  except
  end;
end;


procedure TFProfil.LadeAlleProfile;
begin
  CBHosts.Clear;
  HostInfo.IniFileName:=GetCurrentDir+'/Hosts.ini';
  if HostInfo.LoadProfileItems > 0 then begin
    CBHosts.Items.Assign(HostInfo.Profiles);
    FMain.CBHosts.Clear;
    FMain.CBHosts.Items.Assign(CBHosts.Items);
    LadeProfil(1);
    FMain.CBHosts.ItemIndex:=0;
  end;
end;


procedure TFProfil.BitBtn2Click(Sender: TObject);
begin
  close;
end;

procedure TFProfil.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    FMain.CBHosts.ItemIndex:=CBHosts.ItemIndex;
  except
  end;
end;

procedure TFProfil.HostInfoActionError(Sender: TObject; PrgError: String);
begin
  showmessage(PrgError);
end;

end.
